from game import *
from crash import *
import math
import random

image_player = [
    image('eater.png')]
image_enemy = [
    image('ghost0.png'), image('ghost1.png'), image('ghost2.png')]
image_wall = image('wall.png')
image_bait = image('bait.png')

def walk(m, vx, vy, turn):
    m.x += vx
    m.y += vy
    for w in group(wall):
        dx, dy = m.x-w.x, m.y-w.y
        ax, ay = abs(dx), abs(dy)
        sx, sy = m.sx+w.sx, m.sy+w.sy
        tx, ty = sx*turn, sy*turn
        if ax < sx and ay < sy:
            if vx*dx < 0 and ay <= ty or vy and ax > tx:
                vx = 0
                m.x = w.x+math.copysign(sx, dx)
            if vy*dy < 0 and ax <= tx or vx and ay > ty:
                vy = 0
                m.y = w.y+math.copysign(sy, dy)
    return vx or vy

def player(p):
    v = 0.01
    vx = vy = 0
    if key(LEFT):
        vx, r = -v, 0.5
    elif key(RIGHT):
        vx, r = v, 0
    elif key(UP):
        vy, r = v, 0.25
    elif key(DOWN):
        vy, r = -v, 0.75
    x, y = p.x, p.y
    if walk(p, vx, vy, 0.85):
        p.vx, p.vy = vx, vy
    else:
        p.x, p.y = x, y
        walk(p, p.vx, p.vy, 0.85)
    if p.x != x or p.y != y:
        p.time += 1
    for e in group(enemy):
        d = math.dist((p.x, p.y), (e.x, e.y))
        if d < (p.sx+e.sx)/5:
            new_crash(p.x, p.y, 0.01, 20, 0.98)
            p.life = 0
    n = 0
    for b in group(bait):
        if b.state == 0:
            n += 1
            d = math.dist((p.x, p.y), (b.x, b.y))
            if d < (p.sx+b.sx)/2:
                score(1)
                b.sx = b.sy = 0
                b.state = 1
            elif (key(LSHIFT) or key(RSHIFT)) and d < (p.sx+b.sx)*2:
                b.x += (p.x-b.x)*0.2
                b.y += (p.y-b.y)*0.2
    if n == 0:
        for b in group(bait):
            b.x, b.y = b.ox, b.oy
            b.sx = b.sy = b.size
            b.state = 0

def enemy(e):
    vlist = [(e.vx, e.vy), (e.vy, e.vx), (-e.vy, -e.vx)]
    for p in group(player):
        if e.state == 0:
            vlist.sort(key=lambda t: 
                math.dist((e.x+t[0], e.y+t[1]), (p.x, p.y)))
        elif e.state == 1:
            vlist.sort(key=lambda t: 
                math.dist((e.x+t[0], e.y+t[1]), (p.x, p.y)), 
                reverse=True)
        elif e.state == 2:
            vlist.sort(key=lambda t: 
                math.dist((e.x+t[0], e.y+t[1]), 
                (p.x+math.copysign(p.sx*4, p.vx), 
                p.y+math.copysign(p.sy*4, p.vy))))
    x, y = e.x, e.y
    for vx, vy in vlist:
        v = min(0.011, 0.009+score()*0.000001)
        if vx:
            vx = math.copysign(v, vx)
        if vy:
            vy = math.copysign(v, vy)
        if walk(e, vx, vy, 0.9):
            if (e.x-x)*e.vx >= 0 and (e.y-y)*e.vy >= 0:
                e.vx, e.vy = vx, vy
                break
        e.x, e.y = x, y

def wall(w):
    pass

def bait(b):
    pass

maze =[
    '###################',
    '#........#........#',
    '#.##.###.#.###.##.#',
    '#........0........#',
    '####.#.#####.#.####',
    '#.1..#...#...#..2.#',
    '#.##.###.#.###.##.#',
    '#.#..#...#...#..#.#',
    '#.#.##.#####.##.#.#',
    '#........P........#',
    '###################',
]

def start():
    score()
    table = {
        'P':(player, image_player[0]), 
        '0':(enemy, image_enemy[0]), 
        '1':(enemy, image_enemy[1]), 
        '2':(enemy, image_enemy[2]), 
        '#':(wall, image_wall), 
        '.':(bait, image_bait), 
    }
    size = 0.05
    for ri, row in enumerate(maze):
        for ci, cell in enumerate(row):
            x = (ci-(len(row)-1)/2)*size*2
            y = ((len(maze)-1)/2-ri)*size*2+size*0.3
            func, image = table[cell]
            m = add(func, image, size, x, y)
            if func == enemy:
                m.vx = random.choice([0.009, -0.009])
                m.state = int(cell)
            if func == bait:
                m.ox, m.oy = m.x, m.y
                m.sx = m.sy = m.size = 0.025

run(start, 1280, 720, (0.1, 0.5, 0.3), False, (0.6, 1, 0.6))
